'OSDSTICK.BAS:  OnScreen Simmstick Modul 

'Hardware:  PD 6465 from NEC
'           AT90S2313

'Autor: Hartmut Wendt  

'History:

'V1.00 first release


$regfile = "2313def.dat"
$crystal = 8000000
$baud = 9600
'$lib "mcsbyte.lib"

'**** declaration *************************************************************
Declare Sub Clear
Declare Sub Byte_trans(byval Osd_byte As Byte)
Declare Sub 2byte_trans(byval Osd_byte1 As Byte , Byval Osd_byte2 As Byte )
Declare Sub Write_txt
Declare Sub Get_xy(byval Xypos As Byte)


'**** define variables ********************************************************
Dim Osd_byte As Byte
Const Loeschen = &H7F
Dim Osd_l As Byte
Dim S1 As String * 25
Dim L As Byte
Dim K As Byte
Dim Bg_color As Byte
Dim Bg_assignment As Byte

'**** port declaration ********************************************************
Ddrb = &B10100010                                           'set DDR Register Port B
Ddrd = &B00100000                                           'set DDR Register Port D

                                                            'Busy input
'Busy Alias Portb.0                                          'Clock output
Clk Alias Portb.7                                           'Strobe output
Cspin Alias Portb.1                                         'Data output
Daten Alias Portb.5
Led Alias Portd.5

'Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High

'Config Spi = Soft , Din = Portb.6 , Dout = Portb.5 , Clock = Portb.7 , Ss = None

'Spiinit
Waitms 500
Set Portd.5
Set Cspin
Set Clk

Gosub Grundeinstellung
'Clear
Bg_color = 1

'S1 = Lookupstr(0 , Text1 )                                  'show copyright
'Write_txt

Enable Interrupts

Do
  'Main loop
  L = Inkey()                                               'Get data from serial port
  If L = "#" Then
     'receive command
     L = Waitkey()
     Select Case L
     Case "c" : Clear                                       'Clear screen

     Case "b"
               L = Waitkey()
               If L = &H31 Then                             'blink on
                 Byte_trans &B10001000

               Else
                 Byte_trans &B10000000                      'blink off

               End If

     Case "s"                                               'screen color
               L = Waitkey()
               If L < &H38 Then Bg_color = L - &H30
               Shift Bg_color , Left
               L = &B00100000 + Bg_color
               Byte_trans L

     Case "g"                                               'gotoXY
               Get_xy &B10100000                            'set x position
               Get_xy &B10010000                            'set y position


     Case "m"                                               'video mode
               L = Waitkey()
               If L = &H30 Then                             'display on, chars white
                 'set background
'                 L = &B11001000 + Bg_color
'                 Byte_trans L
                 'display on
                 Byte_trans &B01000001                      'video extern

               Elseif L = &H31 Then                         'display on, chars transparent
                 'set background
                 L = &B11010000 + Bg_color
                 Byte_trans L
                 Byte_trans &B11110101                      'video extern
                 Byte_trans &B11101111                      'display on

               Elseif L = &H32 Then                         'display off,
                 'display off
                 Byte_trans &B11100111

               Elseif L = &H33 Then                         'display on, solid background
                 'set background
'                 L = &B11001000 + Bg_color
'                 Byte_trans L
                 Byte_trans &B01000101                      'video intern

               End If

     End Select

  Elseif L >= &H20 And L < &H80 Then
    'receive any char
     L = L - &H20
     L = Lookup(l , Charset )
     'Byte_trans L
     2byte_trans &B11000000 , L
  End If


  'ext. watchdog reset
  'If Portd.6 = 0 Then
  '  Portd.6 = 1
  'Else
  '  Portd.6 = 0
  'End If
Loop

End                                                         'end program


'(
Sub Byte_shift(byval Osd_byte As Byte)
'send a byte to the uPD6450
   Dim Osd_j As Byte
   Warten:
   If Busy = 0 Then
      For Osd_j = 1 To 8
         If Osd_byte.7 = 1 Then
            Set Daten
         Else
            Reset Daten
         End If
         Clk = 0
         Waitus 3
         Clk = 1
         Waitus 3
         Rotate Osd_byte , Left , 1
         Clk = 0
      Next
   Else
      Goto Warten
   End If

   Stb = 1                                                  'Strobe Impuls
   Waitus 1
   Stb = 0

End Sub
')                                                           '


Sub Byte_trans(byval Osd_byte As Byte)

   Reset Cspin
   Waitus 6
   Shiftout Daten , Clk , Osd_byte , 1 , 8 , 1
   Waitus 6
   Set Cspin
   Waitus 6
End Sub


Sub 2byte_trans(byval Osd_byte1 As Byte , Byval Osd_byte2 As Byte )

   Reset Cspin
   Waitus 6
   Shiftout Daten , Clk , Osd_byte1 , 1 , 8 , 1
'   Waitus 6
   Shiftout Daten , Clk , Osd_byte2 , 1 , 8 , 1
   Waitus 6
   Set Cspin
   Waitus 6

End Sub



Grundeinstellung:
   Clear
   'Byte_trans &B00000000                                    'Video RAM Batch Clear command
   'Byte_trans &B00011100                                    'Display control command
   'Byte_trans &B01000101                                    'internal Mode
 '  Byte_trans &B01010010                                    'oscillation method
   Byte_trans &B01001011                                    'Video Signal Method PAL
   Byte_trans &B00110011                                    'background control command

   2byte_trans &B10010000 , &B00000111                      'Video level
   2byte_trans &B10000000 , &B11000111                      'positon control


'(   Byte_trans &B01000110                                  'assignment command for display position vertikal address
   Byte_trans &B11000110                                    'assignment command for display position horizontal adress


   Byte_trans &B11111100                                    'format assignment command
   Byte_trans &B11101101                                    'display on/off,blink,and LC oscillation commands
   Byte_trans &B11001001                                    'background internal video signalcolor assinment command
   Byte_trans &B10000000                                    'blink data command for each character
   Byte_trans &B11110111                                    'external/internal video switching
')
Return



Sub Clear
'clears the screen
   Byte_trans &B00000000                                    'Video RAM Batch Clear command
   'Waitms 50
   Byte_trans &B00011100                                    'Display control command
   Byte_trans &B01000101
End Sub




Sub Get_xy(byval Xypos As Byte)
'set x or y position for text input via com
  L = Waitkey()
  K = Waitkey()
  If L >= &H30 And K >= &H30 Then
    L = L - &H30
    K = K - &H30
    L = L * 10
    L = L + K
    L = L + Xypos
    Byte_trans L
  End If
End Sub


Charset:
'     20      21     22     23     24     25     26     27     28     29     2A     2B     2C     2D     2E     2F
Data &H6F , &H69 , &H7F , &H6F , &H6F , &H6F , &H6F , &H7E , &H74 , &H75 , &H79 , &H7B , &H80 , &H7C , &H81 , &H29
'     30      31     32     33     34     35     36     37     38     39     3A     3B     3C     3D     3E     3F
Data &H00 , &H01 , &H02 , &H03 , &H04 , &H05 , &H06 , &H07 , &H08 , &H09 , &H84 , &H83 , &H76 , &H7D , &H77 , &H6A
'     40      41     42     43     44     45     46     47     48     49     4A     4B     4C     4D     4E     4F
Data &H6F , &H0A , &H0B , &H0C , &H0D , &H0E , &H0F , &H10 , &H11 , &H12 , &H13 , &H14 , &H15 , &H16 , &H17 , &H18
'     50      51     52     53     54     55     56     57     58     59     5A     5B     5C     5D     5E     5F
Data &H19 , &H1A , &H1B , &H1C , &H1D , &H1E , &H1F , &H20 , &H21 , &H22 , &H23 , &H73 , &H6C , &H72 , &H68 , &H6B
'     60      61     62     63     64     65     66     67     68     69     6A     6B     6C     6D     6E     6F
Data &H66 , &H2A , &HAB , &H2C , &H2D , &H2E , &H2F , &H30 , &H31 , &H32 , &H33 , &H34 , &H35 , &H36 , &H37 , &H38
'     70      71     72     73     74     75     76     77     78     79     7A     7B     7C     7D     7E     7F
Data &H39 , &H3A , &H3B , &H3C , &H3D , &H3E , &H3F , &H40 , &H41 , &H42 , &H43 , &H44 , &H45 , &H46 , &H5E , &H75


